
%{
#include <string.h>
#include "unitesLexicales.h"
char lexeme[256];
int valeur;
float valeurf;
int noligne=1;
%}


%%

"'BEGIN'"    {return(BBEGIN);}
"'END'"   {return(BEND);}

"'REAL'"			{return(REAL);}
"'INTEGER'"		{return(INTEGER);}
"'BOOLEAN'"       {return(BOOLEAN);}

"'TRUE'"              {return(BTRUE);}
"'FALSE'"             {return(BFALSE);}

"'ARRAY'"                 {return(ARRAY);}
"'OWN'"                   {return(OWN);}

"'SWITCH'"                 {return(SWITCH);}

"'PROCEDURE'"                 {return(PROCEDURE);}

"'VALUE'"                 {return(VALUE);}

"'STRING'"                 {return(STRING);}

"'LABEL'"                {return(LABEL);}
"'GOTO'"                 {return(GOTO);}

[0-9]+                 { valeur = atoi(yytext);return(NBR_INT);}
[0-9]+[.][0-9]+      { valeurf = (float)atof(yytext);return(NBR_REAL);}
[0-9]+[.]            { valeurf = (float)atof(yytext);return(NBR_REAL);}
[.][0-9]+            { valeurf = (float)atof(yytext);return(NBR_REAL);}


"+"                 {return(PLUS);}
"-"                 {return(MINUS);}
"*"                 {return(MULT);}
"/"                 {return(DIV);}
"%"                 {return(DIVENT);}

"."                 {return(DOT);}
","                 {return(COMMA);}
":="                {return(AFFECT);}
":"                 {return(DOUBLEDOT);}
";"                 {return(COMMADOT);}
"("                 {return(BRACKETL);}
")"                 {return(BRACKETR);}
"["                 {return(ARRAYBRACKETL);}
"]"                 {return(ARRAYBRACKETR);}

"<="            {return(NOTGREATER);}
">="            {return(NOTLESS);}
"<"             {return(LESS);}
">"             {return(GREATER);}
"="             {return(EQUAL);}
"<>"            {return(NOTEQUAL);}

"'POWER'"              {return(POWER);}   

"'IF'"                 {return(IF);}
"'ELSE'"               {return(ELSE);}
"'THEN'"               {return(THEN);}

"'WHILE'"              {return(WHILE);}
"'FOR'"                {return(FOR);}
"'STEP'"                 {return(STEP);}
"'DO'"                 {return(DO);}
"'UNTIL'"                 {return(UNTIL);}

"'EQUIV'"                 {return(EQUIV);}
"'OR'"                 {return(OR);}
"'AND'"                 {return(AND);}
"'NOT'"                 {return(NOT);}

"'COMMENT'"[^\n]*[\n]    {noligne++;}

["][^"]*["]           {strcpy(lexeme,yytext);return(OPENSTRING);}

[A-Za-z][A-Za-z0-9]* {strcpy(lexeme,yytext); return(IDENT);}
[ \t]			;
\n			{noligne++;}

[\+\-\*\{\}\/\[\(\)\]\!\=\,\<\>\.]			{return((int)*yytext);}

%%


/*extern*/ 
/*extern*/ 
/*
int main(int argc, char **argv) {
    int uniteCourante;
    
    uniteCourante = yylex();
    while (uniteCourante != 0) {
        printf("%d : unite %d",noligne, uniteCourante);

        if (uniteCourante == IDENT)
            printf(" (lexeme: '%s')\n", lexeme);
        else if (uniteCourante == NBR_INT)
            printf(" (valeur %d)\n", valeur);
	else if(uniteCourante == NBR_REAL)
		printf(" (valeur %f)\n", valeurf);
        else if (uniteCourante == OPENSTRING)
            printf(" (string: '%s')\n", lexeme);
        else
            printf("\n");
        
        uniteCourante = yylex();
    }
}

*/
