#ifndef GEN_H
#define GEN_H

#include "dictionnaire.h"

#define SIZE_STR 128

typedef struct BOUCLE
{
    int id;
    struct BOUCLE *next;
}Boucle;


/**************************************** Interface utilisateur **************************************************/
void NegInt();
void NegFloat();
void SetTabHeadStack(char *name);

void BoucleAddEntry();

void BoucleCleanEntry();

void CreateFileData(unsigned char * name);

void CloseFileData(void);

void CreateFileText(unsigned char * name);

void CloseFileText(void);

void AddStaticIntData(char * name);

void AddStaticFloatData(char * name);

void AddStaticBoolData(char * name);

void AddStaticArrayData(char * name);

void DisplayString(char* string);

void DisplayVarInt(char* name);

void DisplayVarBool(char* name);

void DisplayVarFloat(char* name);

void DisplayInt(int val);

void DisplayBool(int val);

void DisplayFloat(float val);

void DisplayStackHead(SYMType type);

void ReadString(void);

// $t1 < $t0  ;  2em pile < sommet pile
void LessThan(void);

// $t1 <= $t0  ;  2em pile <= sommet pile
void LessThanEqual(void);

// $t1 > $t0  ;  2em pile > sommet pile
void GreaterThan(void);

// $t1 >= $t0  ;  2em pile >= sommet pile
void GreaterThanEqual(void);

// $t1 = $t0  ;  2em pile = sommet pile
void Equal(void);

// $t1 != $t0  ;  2em pile != sommet pile
void NotEqual(void);

// converti le sommet de pile (variable courante) int en float
void IntToFloat(void);

// converti le sommet de pile (variable courante) float en int
void FloatToInt(void);

// converti le second de pile float en int
void IntToFloatSecond(void);

// converti le second de pile float en int
void FloatToIntSecond(void);

// negation logique du sommet de pile (variable courante)
void Not(void);

// et logique des 2 variables en sommet de pile
void And(void);

// ou logique des 2 variables en sommet de pile
void Or(void);

// addition des 2 variables int en sommet de pile
void AddInt(void);

// soustraction des 2 variables int en sommet de pile
// $t1 - $t0  ;  2em pile - sommet pile
void SubInt(void);

// multiplication des 2 variables int en sommet de pile
void MulInt(void);

// division des 2 variables int en sommet de pile
// $t1 / $t0  ;  2em pile /0 sommet pile
void DivInt(void);

// addition des 2 variables float en sommet de pile
void AddFloat(void);

// soustraction des 2 variables float en sommet de pile
// $f1 - $f0  ;  2em pile - sommet pile
void SubFloat(void);

// multiplication des 2 variables float en sommet de pile
void MulFloat(void);

// division des 2 variables float en sommet de pile
// $f1 / $f0  ;  2em pile /0 sommet pile
void DivFloat(void);

// cree un block
void CreateBlock();

// ajouter une variable "name" locale a un block
void AddVarBlock(char* name, int reservation);

// clore un block (liberer la place)
void EndBlock();

// creer le label d'une procedure
void CreateProc(char * name);

// appel d'une procedure
void CallProc(char * name);

// fin d'appel d'une procedure
void EndCallProc(char * name);

// retour d'une procedure
void ReturnProc(char * name);

// Reference d'une variable en sommet de pile
void SetReferenceStack(char * name);

// Libere la place du sommet de pile
void FreeStack(void);

// met une constante entiere en sommet de pile
void SetConstIntStack(int i);

// met uneconstante booleene sur la pile
void SetConstBoolStack(int i);
	
//  met une constante flotante en sommet de pile
void SetConstFloatStack(float i);

// met une var sur la pile (pour affectation, exp arith,...)
void SetStack(char* name);

// affectation
void GetStack(char* name);

void GetArrayValueStack(char* name);

void SetArrayValueStack(char* name);

// creer le label d'un if et met a jour les compteurs
void If();

// teste si la condition est vrai
void Then();

// fin the debut else
void EndThen();

// else
void Else();

// else
void EndElse();

// label fin if et mise a jour des compteurs
void EndIf();

// creer le label d'un while et met a jour les compteurs
void While();

// teste si la condition est vrai
void WhileDo();

// label While if et mise a jour des compteurs
void EndWhile();

// creer le label d'un for et met a jour les compteurs
void For();

void VarFor();

void ForDo(char* name);

// label fin if et mise a jour des compteurs
void EndFor();


#endif
